package lebrijo.school.dao;

import java.util.List;

import lebrijo.school.model.Registry;

/**
 * The DAO interface for the Registry entity.
 */
public interface IRegistryDao {
	/**
	 * Return the persistent entities returned from a named query.
	 */
	public List findByNamedQuery(String queryName);
	/**
	 * Return the persistent entities returned from a named query with named parameters.
	 */
	public List findByNamedQuery(String queryName, String[] paramNames, Object[] paramValues);
	/**
	 * Find an entity by its id (primary key).
	 * @return The found entity instance or null if the entity does not exist.
	 */
	public Registry findRegistryById(java.lang.String id);
	/**
	 * Return all persistent instances of the <code>Registry</code> entity.
	 */
	public List<Registry> findAllRegistries();
	/**
	 * Make the given instance managed and persistent.
	 */
	public void persistRegistry(Registry registry);
	/**
	 * Remove the given persistent instance.
	 */
	public void removeRegistry(Registry registry);
}