package lebrijo.school.dao;

import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import lebrijo.school.model.Schoolcertificate;

import org.springframework.stereotype.Repository;

/**
 * The DAO class for the Schoolcertificate entity.
 */
@Repository
public class SchoolCertificatesJPADao implements ISchoolCertificatesDao {
    @PersistenceContext
    private EntityManager em;

	public SchoolCertificatesJPADao() {
		super();
	}
	/**
	 * Return the persistent entities returned from a named query.
	 */
	public List findByNamedQuery(String queryName) {
		Query queryObject = em.createNamedQuery(queryName);
		return queryObject.getResultList();
	}
	/**
	 * Return the persistent entities returned from a named query with named parameters.
	 */
	public List findByNamedQuery(String queryName, String[] paramNames, Object[] paramValues) {
		if (paramNames.length != paramValues.length) {
			throw new IllegalArgumentException();
		}
		Map<String, Object> params = new java.util.HashMap<String, Object>(paramNames.length);
		for (int i = 0; i < paramNames.length; ++i) {
			params.put(paramNames[i], paramValues[i]);
		}
		
		Query queryObject = em.createNamedQuery(queryName);
		if (params != null) {
			for (Map.Entry<String, ?> entry : params.entrySet()) {
				queryObject.setParameter(entry.getKey(), entry.getValue());
			}
		}
		return queryObject.getResultList();

	}
	/**
	 * Find an entity by its id (primary key).
	 * @return The found entity instance or null if the entity does not exist.
	 */
	public Schoolcertificate findSchoolcertificateById(java.lang.String id) {
		return (Schoolcertificate)em.find(Schoolcertificate.class, id);
	}
	/**
	 * Return all persistent instances of the <code>Schoolcertificate</code> entity.
	 */
	@SuppressWarnings("unchecked")
	public List<Schoolcertificate> findAllSchoolcertificates() {
        try {
    		String jpqlString = "select schoolcertificate from " + Schoolcertificate.class.getSimpleName() + " schoolcertificate";
            Query query = em.createQuery( jpqlString );
            return query.getResultList();
        }
        finally {
            if (em != null) {
                em.close();
            }
        }
	}
	/**
	 * Make the given instance managed and persistent.
	 */
	public void persistSchoolcertificate(Schoolcertificate schoolcertificate) {
		em.persist(em.merge(schoolcertificate));
	}
	/**
	 * Remove the given persistent instance.
	 */
	public void removeSchoolcertificate(Schoolcertificate schoolcertificate) {
		/*In JPA, objects detach automatically when they are serialized or when a persistence context ends.
		 The merge method returns a managed copy of the given detached entity.*/
		em.remove(em.merge(schoolcertificate));
	}
}