package lebrijo.school.services;

import java.util.List;

import lebrijo.school.model.Registry;

/**
 * The service interface for the Registry entity.
 */
public interface IRegistryService {
	/**
	 * Find an entity by its id (primary key).
	 * @return The found entity instance or null if the entity does not exist.
	 */
	public Registry findRegistryById(java.lang.String id) throws Exception;
	/**
	 * Return all persistent instances of the <code>Registry</code> entity.
	 */
	public List<Registry> findAllRegistries() throws Exception;
	/**
	 * Make the given instance managed and persistent.
	 */
	public void persistRegistry(Registry registry) throws Exception;
	/**
	 * Remove the given persistent instance.
	 */
	public void removeRegistry(Registry registry) throws Exception;
}