package lebrijo.school.services;

import java.util.List;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import org.springframework.context.ApplicationContext;
import lebrijo.school.model.Schoolcertificate;
import lebrijo.school.dao.ISchoolCertificatesDao;

/**
 * The service class for the Schoolcertificate entity.
 */
@Transactional(propagation=Propagation.REQUIRED)
public class SchoolCertificatesSpringService implements ISchoolCertificatesService {
	/**
	 * The dao instance injected by Spring.
	 */
	private ISchoolCertificatesDao dao;
	/**
	 * The service Spring bean id, used in the applicationContext.xml file.
	 */
	private static final String SERVICE_BEAN_ID = "SchoolCertificatesService";
	
	public SchoolCertificatesSpringService() {
		super();
	}
	/**
	 * Returns the singleton <code>ISchoolCertificatesService</code> instance.
	 */
	public static ISchoolCertificatesService getInstance(ApplicationContext context) {
		return (ISchoolCertificatesService)context.getBean(SERVICE_BEAN_ID);
	}
	/**
	 * Find an entity by its id (primary key).
	 * @return The found entity instance or null if the entity does not exist.
	 */
	@Transactional(propagation=Propagation.NEVER, readOnly=true)
	public Schoolcertificate findSchoolcertificateById(java.lang.String id) throws Exception {
		try {
			return getDao().findSchoolcertificateById(id);
		} catch (RuntimeException e) {
			throw new Exception("findSchoolcertificateById failed with the id " + id + ": " + e.getMessage());
		}
	}
	/**
	 * Return all persistent instances of the <code>Schoolcertificate</code> entity.
	 */
	@Transactional(propagation=Propagation.NEVER, readOnly=true)
	public List<Schoolcertificate> findAllSchoolcertificates() throws Exception {
		try {
			return getDao().findAllSchoolcertificates();
		} catch (RuntimeException e) {
			throw new Exception("findAllSchoolcertificates failed: " + e.getMessage());
		}
	}

	/**
	 * Make the given instance managed and persistent.
	 */
	public void persistSchoolcertificate(Schoolcertificate schoolcertificate) throws Exception {
		try {
			getDao().persistSchoolcertificate(schoolcertificate);
		} catch (RuntimeException e) {
			throw new Exception("persistSchoolcertificate failed: " + e.getMessage());
		}
	}
	/**
	 * Remove the given persistent instance.
	 */
	public void removeSchoolcertificate(Schoolcertificate schoolcertificate) throws Exception {
		try {
			getDao().removeSchoolcertificate(schoolcertificate);
		} catch (RuntimeException e) {
			throw new Exception("removeSchoolcertificate failed: " + e.getMessage());
		}
	}

	/**
	 * Called by Spring using the injection rules specified in 
	 * the Spring beans file "applicationContext.xml".
	 */
	public void setDao(ISchoolCertificatesDao dao) {
		this.dao = dao;
	}
	public ISchoolCertificatesDao getDao() {
		return this.dao;
	}
}